#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sstream>
#include <string>
#include "sqludr.h"

using namespace tmudr;
// C++ QATmudf
// Note: This code is the same as shown in the tutorial on the wiki
// https://wiki.trafodion.org/wiki/index.php/Tutorial:_The_object-oriented_UDF_interface

class QATmudf : public UDR
{
public:
  QATmudf ();

  void describeParamsAndColumns(UDRInvocationInfo &info);
  void processData(UDRInvocationInfo &info,
                   UDRPlanInfo &plan);

private:
};

extern "C" UDR * QA_TMUDF(const UDRInvocationInfo *info)
{
  return new QATmudf();
}

QATmudf::QATmudf()
{
}


void QATmudf::describeParamsAndColumns(UDRInvocationInfo &info)
{
  info.addPassThruColumns(0);
}

void QATmudf::processData(UDRInvocationInfo &info, UDRPlanInfo &plan)
{
  while (getNextRow(info))
  {
    info.copyPassThruData();
    emitRow(info);
  }
}


