create schema mytest;
set schema mytest;

create library qaTmudfLib file '<mydir>/qaTmudfTest.so';

create table mytable (c1 nchar(10), c2 nchar varying(10));
insert into mytable values (_ucs2'aaa', _ucs2'bbb');

create table_mapping function qaTmudfGeneral()
external name 'QA_TMUDF'
language cpp
library qaTmudfLib;

select char_length(c1), converttohex(c1), char_length(c2), converttohex(c2) from mytable;

select char_length(c1), converttohex(c1), char_length(c2), converttohex(c2) from
UDF(qaTmudfGeneral(TABLE(select * from mytable)));

select * from 
UDF(qaTmudfGeneral(TABLE(select * from mytable))) x1, mytable x2
where x1.c1 = x2.c1;

select * from
UDF(qaTmudfGeneral(TABLE(select * from mytable))) x1, mytable x2
where x1.c2 = x2.c2;

drop schema mytest cascade;

